diff --git a/src/demo/demo.h b/src/demo/demo.h
index 9474dddaf7..8d91c8768e 100644
--- a/src/demo/demo.h
+++ b/src/demo/demo.h
@@ -166,6 +166,7 @@ int hud_schedule(const char* demoname);
 // this result ought be propagated out so that the demo is reported as having
 // been aborted, rather than having failed.
 int demo_render(struct notcurses* nc);
+int demo_render_nblock(struct notcurses* nc);
 
 #define DEMO_RENDER(nc) { int demo_render_err = demo_render(nc); if(demo_render_err){ return demo_render_err; }}
 
diff --git a/src/demo/hud.c b/src/demo/hud.c
index d4ea6825fa..ff1e8b6513 100644
--- a/src/demo/hud.c
+++ b/src/demo/hud.c
@@ -470,7 +470,8 @@ int demo_nanosleep_abstime(struct notcurses* nc, const struct timespec* abstime)
 }
 
 // FIXME needs to pass back any ncinput read, if requested...hrmmm
-int demo_render(struct notcurses* nc){
+static char32_t
+demo_render_internal(struct notcurses* nc){
   if(interrupted){
     return 1;
   }
@@ -516,8 +517,23 @@ int demo_render(struct notcurses* nc){
     ncplane_styles_off(hud, NCSTYLE_BOLD);
   }
   ncinput ni;
-  char32_t id;
-  id = demo_getc_nblock(nc, &ni);
+  return demo_getc_nblock(nc, &ni);
+}
+
+int demo_render_nblock(struct notcurses* nc){
+  char32_t id = demo_render_internal(nc);
+  int ret = notcurses_render_nblock(nc);
+  if(ret){
+    return ret;
+  }
+  if(id == 'q'){
+    return 1;
+  }
+  return 0;
+}
+
+int demo_render(struct notcurses* nc){
+  char32_t id = demo_render_internal(nc);
   int ret = notcurses_render(nc);
   if(ret){
     return ret;
